%
% BibTeX references for Diploma thesis
% Marcel Baur <mbaur(at)iiic.ethz.ch>
%
% $Id: da.bib,v 1.29 2003-03-10 10:59:38 baurma Exp $
% $Revision: 1.29 $
%
% ------------------------------------------------------------------------

@book{
    stoller,
    key       = "Testing Concurrent Java Programs",
    author    = "Scott D. Stoller",
    title     = "Testing Concurrent Java Programs using Randomized Scheduling",
    address   = "Computer Science Dept., State University of New York at
                 Stony Brook, USA",
    year      = "2002",
    note      = "\\ 
                 \myurl{http://www.cs.sunsyb.edu/~stoller}"
}

% ------------------------------------------------------------------------

@book{
    JavaLang,
    key       = "The Java Language Specification",
    author    = "James Gosling and Joy, Bill and 
                 Steel, Guy and Bracha, Gilad",
    editor    = "",
    title     = "The Java Language Specification",
    publisher = "Addison-Wesley",
    year      = "2000",
    volume    = "",
    series    = "",
    edition   = "2nd",
    address   = "USA",
    month     = "",
    note      = "\\ 
                 \myurl{http://java.sun.com/docs/books/jls}"
}

% ------------------------------------------------------------------------

@book{
    javavm,
    key       = "The Java Virtual Machine Specification",
    author    = "Tim Londholm and Frank Jellin",
    editor    = "",
    title     = "The Java Virtual Machine Specification",
    publisher = "Addison-Wesley",
    year      = "1999",
    volume    = "",
    series    = "",
    edition   = "Second",
    address   = "USA",
    month     = "",
    note      = "\\ 
                 \myurl{http://java.sun.com/docs/books/vmspec}"
}

% ------------------------------------------------------------------------

@book{
    artho,
    key       = "Finding faults in multi-threaded programs",
    author    = "Cyrille Artho",
    title     = "Finding faults in multi-threaded programs",
    school    = "Swiss Federal Institute of Technology (ETH Z{\"u}rich)",
    month     = "March",   
    year      = "2001",
    address   = "Diploma Thesis. Institute of Computer Systems, 
                 ETH Zentrum, RZ H15, CH-8092 Z{\"u}rich",
    publisher = "",
    note      = "\\
                 \myurl{http://www.inf.ethz.ch/personal/artho/mthesis.pdf}"
}

% ------------------------------------------------------------------------
% jkanerva(at)inxight.com

@book{
    kanerva,
    key       = "The Java FAQ",
    author    = "Jonni Kanerva",
    title     = "The Java FAQ",
    publisher = "Addison-Wesley",
    year      = "1997",
    volume    = "",
    series    = "",
    address   = "",
    edition   = "",
    month     = "",
    note      = "\mbox{ISBN 0-201-63456-2}, \\ 
                \myurl{http://java.sun.com/docs/books/faq}"
}

% ------------------------------------------------------------------------

@book{
    bruening,
    key       = "Systematic Testing of Multithreaded Programs",
    author    = "Derek Bruening and John Chapin",
    title     = "Systematic Testing of Multithreaded Programs",
    year      = "2000",
    month     = "April",
    journal   = "MIT/LCS Technical Memo, LCS-TM-607",
    note      = "\\ 
                 \myurl{http://web.mit.edu/iye/www/pubs.html}"
}

% ------------------------------------------------------------------------

@book {  
  purify,
  key         = "Purify Fast Detection of Memory Leaks and Access Errors",
  title       = "Purify: Fast Detection of Memory Leaks and Access Errors",
  proceedings = "Proceedings of the Winter USENIX Conference",
  pages       = "125-136",
  month       = "January",
  year        = "1992"
}

% ------------------------------------------------------------------------

@book {
  gof,
  title     = "Design Patterns: Elements of Reusable Object-Oriented Software",
  author    = "Erich Gamma and Richard Heim and 
               Ralph Johnson and John Vlisside",
  year      = "1994",
  month     = "October",
  note      = "\mbox{ISBN 0-201-63361-2}",
  publisher = "Addison-Wesley"
}

% ------------------------------------------------------------------------

@book {
  javaclass,
  key       = "Byte Code Engineering",
  author    = "Markus Dahm",
  address   = "Freie Universit{\"a}t Berlin",
  note      = ""
}

% ------------------------------------------------------------------------

@book {
 javaclass2,
 key     = "Byte Code Engineering with the JavaClass API",
 title   = "Byte Code Engineering with the JavaClass API",
 author  = "Markus Dahm",
 address = "Technical Report, Freie Universit{\"a}t Berlin",
 year    = "1998"
}

% ------------------------------------------------------------------------

@book {
  bcel,
  key    = "BCEL Byte Code Engineering API",
  title  = "BCEL Byte Code Engineering API",
  author = "Markus Dahm and Jason van Zyl and others",
  year   = "2002",
  note   = "\\ 
            \myurl{http://jakarta.apache.org/bcel}"
}

% ------------------------------------------------------------------------

@book{ 
  dahm01byte,
  author  = "Markus Dahm",
  title   = "Byte Code Engineering with the BCEL API",
  address = "Freie Universit{\"a} at Berlin, 
             Institut f{\"u}r Informatik",
  note    = "Technical Report B-17-98
             \myurl{http://citeseer.nj.nec.com/dahm01byte.html}",
  month   = "April",
  year    = "2001"
}

% ------------------------------------------------------------------------

@book {
  ieee754,
  key       = "IEEE Standard for Binary Floating Point Arithmetic",
  title     = "754-1985 IEEE Standard for Binary Floating-Point Arithmetic",
  year      = "1985",
  pages     = 20,
  isbn      = "ISBN 1-5593-7653-8",
  note      = "ISBN 1-5593-7653-8, 20 pages, IEEE Product No. SH10116-TBR",
  editor    = "",
  publisher = "" 
}

% ------------------------------------------------------------------------

@book {
  javadoc,
  key     = "javadoc",
  author  = "{Sun Microsystems, Inc.}",
  title   = "javadoc",
  note    = "\\ 
             \myurl{http://java.sun.com/j2se/javadoc}"
}

% ------------------------------------------------------------------------

@book {
  blackdown,
  key       = "blackdown",
  author    = "Stephen M. Wynne",
  year      = "2000",
  month     = "January",
  title     = "\mbox{Blackdown.org FAQ}",
  note      = "\\ 
               \myurl{http://www.blackdown.org/java-linux/docs/support/faq-release/FAQ-java-linux.html}",
  publisher = ""
}

% ------------------------------------------------------------------------

@book {
  javase,
  key    = "Java 2 Platform Standard Edition 1.4.1",
  title  = "\mbox{Java 2 Platform, SE v1.4.1 API documentation}",
  author = "{Sun Microsystems, Inc}",
  note   = "\\ 
            \myurl{http://java.sun.com/j2se/1.4.1/docs/api/index.html}"
}

% ------------------------------------------------------------------------

@book {
  suspresume,
  key    = "Why are Thread.stop",
  title  = "Why Are Thread.stop, Thread.suspend, Thread.resume and
            Runtime.runFinalizersOnExit Deprecated?",
  author = "{Sun Microsystems, Inc}",
  note   = "\\ 
            \myurl{http://java.sun.com/products/jdk/1.2/docs/guide/misc/threadPrimitiveDeprecation.html}"
}

% ------------------------------------------------------------------------

@book {
  eugster,
  title     = "Java Virtual Machine with Rollback Procedure allowing 
               Systematic and Exhaustive Testing of Multithreaded Java 
               Programs",
  year      = "2003",
  month     = "March",
  publisher = "",
  author    = "Pascal Eugster",
  note      = "Diploma Thesis",
  address   = "Formal Methods Group, Computer Systems Institute, 
               ETH Zentrum, CH-8092 Z{\"u}rich, Switzerland"
}

% ------------------------------------------------------------------------

@book{
  gagliano,
  title     = "Testing of Java Bytecode Transformations",
  author    = "Horacio S. Gagliano",
  year      = "2002",
  month     = "August",
  address   = "Diploma Thesis. Institute of Computer Systems, ETH Zentrum,
               CH-8092 Z{\"u}rich"
}

% ------------------------------------------------------------------------

@book{ 
  choi98deterministic,
  author = "Jong-Deok Choi and Harini Srinivasan",
  title  = "Deterministic Replay of Java Multithreaded Applications",
  year   = "1998",
  month  = "August",
  note   = "In Proceedings of the SIGMETRICS Symposium on Parallel and 
            Distributed Tools, pp. 48-59, Welches, Oregon \\ 
            \myurl{http://citeseer.nj.nec.com/choi98deterministic.html}"
}

% ------------------------------------------------------------------------

@book {
  bit,
  key    = "BIT: A tool for instrumenting Java bytcodes",
  title  = "{BIT}: A tool for instrumenting Java bytecodes",
  author = "Han Bok Lee and Benjamin G. Zorn",  
  note   = "In Proceedings of the 1997 USENIX Symposium on 
            Internet Technologies and Systems (USITS97), pages 73-82, 
            Monterey, CA, USENIX Association
            \myurl{http://www.cs.colorado.edu/~hanlee/BIT}",
  year   = "1997",
  month  = "December"
}


% ------------------------------------------------------------------------

@book {
  cody,
  title     = "\mbox{Algorithm 722} - {Functions} to Support the \mbox{IEEE} 
               Standard for Binary Floating-Point Arithmetic",
  author    = "W. J. Cody and 
               Jerome T. Coonen",
  note      = "Argonne National Laboratory and C-Labs,
               Volume 19, Issue 4 of ACM Transactions on Mathematical 
               Software (TOMS)",
  publisher = "ACM Press New York",
  issn      = "0098-3500",
  pages     = "443 - 451",
  year      = "1993",
  month     = "December"
  
}

% ------------------------------------------------------------------------

@book {
  greenvsnative,
  key    = "Understanding",
  author = "{Sun Microsystems, Inc}",
  title  = "Understanding Green and Native Thread Differences",
  note   = "\\ 
            \myurl{http://developer.java.sun.com/developer/qow/archive/97}",
  year   = "1997"
}

% ------------------------------------------------------------------------

@book {
  grandesoft,
  key = "Java Grande",
  title = "\mbox{Java Grande Forum Benchmark Suite, Test Version 1.0}",
  author = "",
  address = "\mbox{Edinburgh Parallel Computing Centre (EPCC)}",
  year = "2001",
  note = "\\
         \myurl{http://www.epcc.ed.ac.uk/computing/research_activities/java_grande/threads.html}"
}

% ------------------------------------------------------------------------

@book {
  grande,
  key     = "Java Grande B",
  title   = "A Parallel Java Grande Benchmark Suite",
  author  = "L. A. Smith and J. M. Bull and others",
  address = "EPCC, The King's Building, The University of Edinburgh,
             Mayfield Road, Edinburgh EH93JZ, Scotland, UK"
}

% ------------------------------------------------------------------------

@book {
  netzer,
  author   = "R. Netzer and B. Miller",
  title    = "On the Complexity of Event Ordering for Shared-Memory 
              Parallel Program Executions",
  note     = "In Proceedings of the International Conference on 
              Parallel Processing",
  year     = "1990",
  pages    = "93-97"
}

% ------------------------------------------------------------------------

@book {
  awk,
  key     = "awk",
  author  = "",
  title   = "Awk"
}

% ------------------------------------------------------------------------

@book {
  russinovich,
  author    = "Mark Russinovich and Bryce Cogswell",
  address   = "Department of Computer Science, University of Oregon,
               Eugene OR 97403",
  title     = "Replay For Concurrent Non-Deterministic Shared-Memory 
               Applications",
  note      = "Proceedings of the ACM SIGPLAN '96 conference on 
               Programming language design and implementation \\
               \myurl{http://doi.acm.org/10.1145/231379.231432}",
  isbn      = "0-89791-795-2",
  publisher = "ACM Press, New York",
  year      = "1996",
}

% ------------------------------------------------------------------------

@book {
  osfdce,
  author = "Yuh Ming Yong and David Taylor",
  title  = "Performing Replay in an OSF DCE Environment"
}

% ------------------------------------------------------------------------

@book {
  joie,
  key    = "JOIE",
  title  = "Automatic Program Transformation with JOIE",
  author = "Geoff A. Cohen 
            and David L. Kaminsky
            and Jeffrey S. Chase",
  note   = "\\
            \myurl{http://www.cs.duke.edu/ari/joie}",
  year   = "1999",
  month  = "December"
}

% ------------------------------------------------------------------------

@book {
  jasmin,
  key     = "Jasmin",
  title   = "Jasmin Java Assembler Interface",
  author  = "Jon Meyer",
  address = "New York University Media Research Lab, 719 Broadway, 
             12th Floor, New York NY 10003",
  year    = "1997",
  month   = "March",
  note    = "\\ 
            \myurl{http://mrl.nyu.edu/~meyer/jasmin}"
}

% ------------------------------------------------------------------------

@book {
  barat,
  key   = "Barat",
  title = "Barat",
  year  = "2000",
  month = "October",
  author = "Boris Bokowski 
            and Markus Dahm 
            and Andre Spiegel",
  note  = "\\
           \myurl{http://sourceforge.net/projects/barat}"
}

% ------------------------------------------------------------------------

@book {
  barattech,
  key     = "Barat2",
  title   = "Barat - A Front-End for Java",
  author  = "Boris Bokoswki",
  address = "Freie Universit{\"a}t Berlin",
  year    = "1998",
  month   = "December",
  note    = "Technical Report \\
             \myurl{ftp://ftp.inf.fu-berlin.de/pub/reports/tr-b-98-09.pdf}"
}

% ------------------------------------------------------------------------

@book {
  jtrek,
  key    = "Compaq",
  title  = "JTrek",
  author = "Compaq",
  note   = "\\
            \myurl{http://www.digital.com/java/download/jtrek/index.html}"
}

% ------------------------------------------------------------------------

@book {
  jtrekhp,
  key    = "JTrek2",
  title  = "Compaq JTrek Product Information",
  author = "Compaq",
  note   = "\\
            \myurl{http://h18012.www1.hp.com/java/download/jtrek}"
}
% ------------------------------------------------------------------------

@book {
  jikesbt,
  key     = "Jikes ByteCode Toolkit",
  title   = "Jikes ByteCode Toolkit",
  year    = "2000",
  month   = "March",
  author  = "{IBM alphaWorks}",
  address = "",
  note    = "\\
             \myurl{http://www.alphaworks.ibm.com/tech/jikesbt}"
}

% ------------------------------------------------------------------------

@book {
  cfparse,
  key     = "CFParse",
  title   = "CFParse",
  year    = "2000",
  month   = "September",
  author  = "{IBM alphaWorks}",
  address = "",
  note    = "\\
             \myurl{http://www.alphaworks.ibm.com/tech/cfparse}"
}

% ------------------------------------------------------------------------

@book{
  tai,
  author    = "Kuo-Chung Tai 
               and Richard H. Carver 
               and Evelyn E. Obaid",
  title     = "Debugging Concurrent Ada Programs by Deterministic Execution",
  note      = "IEEE Transactions on Software Engineering, 
               Volume 17, Issue 1, pp. 45-63",
  month     = "January",
  year      = "1991",
  publisher = "IEEE Press, Piscataway, New Jersey"
}

% ------------------------------------------------------------------------

@book {
  mcdowell,
  author    = "Charles E. McDowell and David P. Helmbold",
  title     = "Debugging concurrent programs",
  address   = "University of California at Santa Cruz, California",
  year      = "1998",
  publisher = "ACM Press, New York",
  note      = "ACM Computing Surveys (CSUR), Volume 21, Number 4, pp 593-622 \\
               \myurl{http://doi.acm.org/10.1145/76894.76897}"
}

% ------------------------------------------------------------------------

@book{
  kanzlmueller,
  author  = "Dieter Kranzlm{\"u}ller",
  title   = "Event Graph Analysis for Debugging Massively Parallel Programs",
  address = "GUP Linz, Joh. Kepler University Linz, Altenbergerstr. 69, 
             A-4040 Linz",
  note    = "\\
             \myurl{http://www.gup.uni-linz.ac.at/~dk/thesis}",
  month   = "September",
  year    = "2000"
}

% ------------------------------------------------------------------------

@book {
  instantreplay,
  key       = "Debugging parallel programs with Instant Replay",
  title     = "Debugging parallel programs with Instant Replay",
  author    = "T. J. LeBlanc and J. M. Mellor-Crummey",
  note      = "IEEE Transaction on computers C-36(4):471-482",
  month     = "April",
  year      = "1987",
  publisher = "IEEE Computer Society"

}

% ------------------------------------------------------------------------

@book {
  douglea,
  author    = "Doug Lea",
  title     = "Concurrent Programming in Java: Design Principles and Patterns",
  month     = "November",
  year      = "1999",
  publisher = "Addison-Wesley",
  note      = "ISBN 0-201-31009-0"
}

% ------------------------------------------------------------------------

@book {
  pmgjava,
  key       = "Poor Man's Genericity for Java",
  author    = "Boris Bokowski and Markus Dahm",
  title     = "Poor Man's Genericity for Java",
  year      = "1998",
  address   = "Freie Universit{\"a}t Berlin, 
               Institut f{\"u}r Informatik, Takustr. 9, 14195 Berlin",
  publisher = "Springer Verlag",
  note      = "\\
               \myurl{http://page.inf.fu-berlin.de/~bokowski/pmgjava}"
}

% ------------------------------------------------------------------------

@book {
  konuru,
  key     = "Deterministic Replay of Distributed Java Applications",
  title   = "Deterministic Replay of Distributed Java Applications",
  author  = "Ravi Konuru and Harini Srinivasan and Jong-Deok Choi",
  address = "IBM Thomas J. Watson Research Center, 30 Saw Mill River Road, Hawthorne, NY 10532",
  year    = "2000",
  note    = "14th International Parallel and Distributed Processing Symposium (IPDPS) \\
             \myurl{http://ipdps.eece.unm.edu/2000/papers/konuru.pdf}"
}

% ------------------------------------------------------------------------

@book {
  neri,
  key    = "Debugging distributed applications with replay capabilities",
  title  = "Debugging distributed applications with replay capabilities",  
  year   = "1997",
  author = "Daniel Neri and Laurent Pautet and Samuel Tardieu",
  note   = "\\
            \myurl{http://www.rfc1149.net/download/documents/tardieu-triada97.ps}"
}

% ------------------------------------------------------------------------

@book {
  jnuke,
  key     = "JNuke",
  title   = "JNuke Framework for checking Java Byte Code",
  author  = "{Formal Methods Group}",
  address = "Contact information: Computer Systems Institute, 
             ETH Zentrum, CH-8092 Z{\"u}rich, Switzerland"
}

% ------------------------------------------------------------------------

@book {
  rivet,
  key    = "rivet",
  title  = "Systematic Testing of Multithreaded Java Programs",
  author = "Derek L. Bruening",
  year   = "1999",
  month  = "May",
  note   = "Master Thesis \\
            \myurl{http://web.mit.edu/iye/www/docs/thesis.pdf.gz}"
}

% ------------------------------------------------------------------------

@book {
  yield,
  key    = "yield",
  title  = "The Java Tutorial: Understanding Thread Priority",
  author = "{Sun Microsystems, Inc}",
  note   = "\\
            \myurl{http://java.sun.com/docs/books/tutorial/essential/threads/priority.html}"
}

% ------------------------------------------------------------------------

@book {
  registerbytecode,
  key     = "Register Byte Code",
  title   = "Register Byte Code Optimization",
  author  = "Pascal Eugster",
  month   = "July",
  year    = "2002",
  address = "Computer Systems Institute, 
             ETH Zentrum, CH-8092 Z{\"u}rich, Switzerland"
}

% ------------------------------------------------------------------------

@book {
  bach,
  title     = "The Design of the Unix Operating System",
  author    = "Maurice J. Bach",
  year      = "1986",
  publisher = "Prentice-Hall",
  note      = "ISBN 0-13-201757-1"
}

% ------------------------------------------------------------------------  

@book {
  silberschatz,
  title     = "Operating System Concepts",
  author    = "Abraham Silberschatz and Peter Baer Galvin",
  publisher = "\mbox{John Wiley \& Sons, Inc.}",
  edition   = "\mbox{Fifth}",
  year      = "1997",
  note      = "ISBN 0-471-41714-2 \\
               \myurl{http://os-book.com}"
}

% ------------------------------------------------------------------------  

@book {
  coffman,
  author = "E. G. Coffman and 
            M. J. Elphick and 
            A. Shoshani",
  title  = "System Deadlocks",
  year   = "1977",
  month  = "June",
  note   = "In Computing Surveys, 3(2):67-78 \\ 
            \myurl{http://doi.acm.org/10.1145/356586.356588}"
}

% ------------------------------------------------------------------------  

@book {
  stallings,
  title     = "Operating Systems: Internals and Design Principles",
  edition   = "Fourth",
  author    = "William Stallings",
  year      = "2001",
  publisher = "Prentice Hall, Upper Saddle River, NJ 07458",
  note      = "ISBN 0-13-031999-6 \\
               \myurl{http://www.prenhall.com/stallings}"
}

% ------------------------------------------------------------------------  

@book {
  rtsj,
  title     = "The Real-Time Specification for Java",
  author    = "{The Real-Time for Java Expert Group}",
  publisher = "Addison-Wesley",
  year      = "2000",
  month     = "June",
  note      = "ISBN 0-201-70323-8, \\
               \myurl{http://www.rtj.org/rtsj-V1.0.pdf}"
}

% ------------------------------------------------------------------------  

